#if !defined(FILEATTACH_H)
#define FILEATTACH_H
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <glib.h>

#define FILE_ATTCH_ONE_EXT_SIZE 512
#define FATTACH_BUFF_LEN 1024

typedef struct _attach_file_block{
  guint count;
  GMutex *mutex;
  int max_id;
  long pkt_no;
  GList *files;  /*ファイル情報*/
  gchar *ipaddr; 
}attach_file_block_t;

typedef struct _download_file_info{ /* ダウンロードファイル情報 */
  int fileid;
  gchar *filename;  
  size_t size;
  time_t m_time;
  int    ftype;
}download_file_block_t;

typedef struct _file_info{
  GMutex *mutex;
  attach_file_block_t *main_info_ref;
  download_file_block_t *dfcb_ref;
  int fileid;
  gchar *filepath;
  gchar *filename;
  size_t size;
  time_t m_time;
  int ipmsg_fattr;
  size_t offset;  /*未使用*/
  GList *xattrs;  /*未使用*/
}file_info_t;

typedef struct _download_monitor_entry{ /* ダウンロードモニタ用情報 */
  long pkt_no;
  int  status;
  gchar *filenames;
  gchar *username;
}download_monitor_entry_t;

int create_attach_file_block(attach_file_block_t **afcb);
int destroy_attach_file_block(attach_file_block_t **afcb);
int release_attach_file_block(const long pktno,gboolean force);
int ref_attach_file_block(long pktno,const char *ipaddr);
int unref_attach_file_block(long pktno);
int set_attch_file_block_pktno(attach_file_block_t *afcb,const long pktno);
int add_attach_file(attach_file_block_t *afcb,const gchar *path);
int remove_attach_file(attach_file_block_t *afcb,const gchar *path);
int get_attach_file_extention(attach_file_block_t *afcb,const gchar **ext_string);
int refer_attach_file(const long pktno,int fileid,const char **path,size_t *size);
int destroy_download_list(const GList **download_list);
int parse_download_string(const char *string, GList **list);
int get_file_info(const gchar *path,size_t *size,time_t *mtime,int *ipmsg_type);
void show_file_list(attach_file_block_t *afcb);
int add_upload_queue(long pktno,attach_file_block_t *afcb) ;
GList *get_download_monitor_info(void);
int release_download_monitor_entry(download_monitor_entry_t *entry);
#endif  /*  FILEATTACH_H  */
