#if !defined(HOSTINFO_H)
#define HOSTINFO_H
#include <glib.h>

#define DEFAULT_PORT 2425

#define PATH "/apps/g2ipmsg"
#define HOSTINFO_KEY_PORT          "/apps/g2ipmsg/portno"
#define HOSTINFO_KEY_GROUP         "/apps/g2ipmsg/group"
#define HOSTINFO_KEY_NICKNAME      "/apps/g2ipmsg/nickname"
#define HOSTINFO_KEY_MSGSEC        "/apps/g2ipmsg/secret"
#define HOSTINFO_KEY_CONFIRM_MSG   "/apps/g2ipmsg/confirm"
#define HOSTINFO_KEY_BROADCASTS    "/apps/g2ipmsg/broadcasts" /* ブロードキャスト */
#define HOSTINFO_KEY_POPUP         "/apps/g2ipmsg/popup"
#define HOSTINFO_KEY_SOUND         "/apps/g2ipmsg/sound"
#define HOSTINFO_KEY_ENCLOSE       "/apps/g2ipmsg/enclose"
#define HOSTINFO_KEY_CITATION      "/apps/g2ipmsg/cite"
#define HOSTINFO_KEY_LOGFILEPATH   "/apps/g2ipmsg/logfilepath"
#define HOSTINFO_KEY_ENABLE_LOG    "/apps/g2ipmsg/enablelog"
#define HOSTINFO_KEY_LOG_NAME      "/apps/g2ipmsg/enablelogname" /* ログオン名記録 */
#define HOSTINFO_KEY_LOG_IPADDR    "/apps/g2ipmsg/enablelogaddr" /* アドレス記録 */
#define HOSTINFO_KEY_CITE_STRING   "/apps/g2ipmsg/citestring" /* 引用文字 */
#define HOSTINFO_KEY_ABS_TITLE   "/apps/g2ipmsg/absence_titles" /* 不在タイトル */
#define HOSTINFO_KEY_ABS_MSGS   "/apps/g2ipmsg/absence_messages" /* 不在文 */
#define HOSTINFO_KEY_DEBUG   "/apps/g2ipmsg/enable_debug" /* デバッグ文 */
#define HOSTINFO_KEY_MSGWIN_WIDTH   "/apps/g2ipmsg/msg_win_width" /* メッセージウィンドウの幅 */
#define HOSTINFO_KEY_MSGWIN_HEIGHT   "/apps/g2ipmsg/msg_win_height" /* メッセージウィンドウの高さ */
#define HOSTINFO_KEY_RECVWIN_WIDTH   "/apps/g2ipmsg/recv_win_width" /* 受信ウィンドウの幅 */
#define HOSTINFO_KEY_RECVWIN_HEIGHT   "/apps/g2ipmsg/recv_win_height" /* 受信ウィンドウの高さ */
int hostinfo_refer_ipmsg_port(void);
const char *hostinfo_refer_user_name(void);
const char *hostinfo_refer_group_name(void);
const char *hostinfo_refer_nick_name(void);
const char *hostinfo_refer_host_name(void);
const char *hostinfo_refer_nick_name_proto(void);
const char *hostinfo_refer_group_name_proto(void);
const char *hostinfo_refer_ipmsg_cite_string(void);
gboolean hostinfo_refer_ipmsg_default_secret(void);
gboolean hostinfo_refer_ipmsg_default_confirm(void);
gboolean hostinfo_refer_ipmsg_default_popup(void);
gboolean hostinfo_refer_ipmsg_default_sound(void);
gboolean hostinfo_refer_ipmsg_default_enclose(void);
gboolean hostinfo_refer_ipmsg_default_citation(void);
gboolean hostinfo_refer_ipmsg_ipaddr_logging(void);
gboolean hostinfo_refer_ipmsg_logname_logging(void);
gboolean hostinfo_refer_ipmsg_enable_log(void);
gboolean hostinfo_set_ipmsg_default_secret(gboolean val);
gboolean hostinfo_set_ipmsg_default_confirm(gboolean val);
gboolean hostinfo_set_ipmsg_default_popup(gboolean val);
gboolean hostinfo_set_ipmsg_default_sound(gboolean val);
gboolean hostinfo_set_ipmsg_default_enclose(gboolean val);
gboolean hostinfo_set_ipmsg_default_citation(gboolean val);
gboolean hostinfo_set_ipmsg_ipaddr_logging(gboolean val);
gboolean hostinfo_set_ipmsg_logname_logging(gboolean val);
gboolean hostinfo_set_ipmsg_enable_log(gboolean val);
int hostinfo_set_ipmsg_logfile(const char *file);
int hostinfo_set_ipmsg_broadcast_list(GSList *list);
GSList* hostinfo_get_ipmsg_broadcast_list(void);
const char *hostinfo_refer_ipmsg_logfile(void);
int hostinfo_get_normal_send_flags(void);
int hostinfo_set_group_name(const char *groupName);
int hostinfo_set_nick_name(const char *nickName);
int hostinfo_set_ipmsg_port(int port);
int hostinfo_send_broad_cast(const udp_con_t *con,const char *msg,size_t len);

gboolean hostinfo_is_ipmsg_absent(void);
gboolean hostinfo_set_ipmsg_absent(gboolean state);
int hostinfo_get_absent_id(int *index);
int hostinfo_set_absent_id(int index);
int hostinfo_get_absent_title(int index,const char **title);
int hostinfo_set_ipmsg_absent_title(int index,const char *title);
int hostinfo_refer_absent_length(int *max_index);
int hostinfo_refer_absent_message_slots(int *max_index);
int hostinfo_get_absent_message(int index,const char **message);
int hostinfo_set_ipmsg_absent_message(int index,const char *message);
gboolean hostinfo_refer_debug_state(void);

int hostinfo_get_ipmsg_message_window_size(gint *width,gint *height);
int hostinfo_set_ipmsg_message_window_size(gint width,gint height);
int hostinfo_get_ipmsg_recv_window_size(gint *width,gint *height);
int hostinfo_set_ipmsg_recv_window_size(gint width,gint height);

int hostinfo_init_hostinfo(void);
void hostinfo_cleanup_hostinfo(void);
#endif  /* HOSTINFO_H  */
