/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <gnome.h>
#include <glib.h>

#include <panel-applet.h>
#include <gst/gst.h>
#include "interface.h"
#include "support.h"
#include "common.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

gint target_tag;
udp_con_t *udp_con;
static udp_con_t con;

void
read_message(gpointer data,
	     gint source,
	     GdkInputCondition condition) {
  char *msg_buff=NULL;
  size_t len;
  
  gdk_input_remove(target_tag);
  len=0;
  msg_buff=NULL;
  udp_recv_message(udp_con,&msg_buff,&len);
      if (len>0) {
	msg_data_t msg;

	init_message_data(&msg);
	dbg_out("Message arrive\n");
	parse_message(&msg,msg_buff,len);
	free(msg_buff);
	msg_buff=NULL;
	ipmsg_dispatch_message(udp_con,&msg);
	release_message_data(&msg);
      }
  dbg_out("Add socket:%d\n",udp_con->soc);
  target_tag=gdk_input_add(udp_con->soc,GDK_INPUT_READ,read_message,NULL);
}

int
init_ipmsg(void){

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  gst_init (NULL, NULL);
  logfile_init_logfile();
  init_message_info_manager();
  
  memset(&con,0,sizeof(udp_con_t));
  udp_setup_server(&con,hostinfo_refer_ipmsg_port(),PF_INET);
  udp_enable_broadcast(&con);

  udp_con=&con;

  dbg_out("Add socket:%d\n",udp_con->soc);
  target_tag=gdk_input_add(udp_con->soc,GDK_INPUT_READ,read_message,NULL);
  ipmsg_send_br_entry(udp_con,hostinfo_get_normal_send_flags());
  init_sound_system(PACKAGE);

  return 0;
}

void
cleanup_ipmsg(void){
  logfile_shutdown_logfile();
  hostinfo_cleanup_hostinfo();
  dbg_out("UI Thread ended\n");
  cleanup_sound_system();
  udp_release_connection(udp_con);
}

